#include "HAL/HAL.h"
#include "SD_Card/SD_Card.h"
#include <cstring>

int main()
{
	HAL_StopWatchdog();
	HAL_InitClocks();
	HAL_InitPorts();
	SD_Init();
	__enable_interrupt();
	// Wait on SD Card insertion.
	while ( ~ SD_AREG & SD_AFLAG_INSRT)
		;
	SD_MountFS();										// until here, the debug sessions starts normally
	SD_OpentFile("Abba.txt");
	while (1)
		;
	SD_WriteToFile("You can dance\rYou can jive\rHaving the time of your life");
	SD_CloseFile();
	if (SD_EREG)
	{
		// If no errors detected...
		GPIO_setOutputHighOnPin(GPIO_PORT_P5, GPIO_PIN5);
		GPIO_setOutputLowOnPin(GPIO_PORT_P5, GPIO_PIN3);
		while (1)
			;
	}
	else
	{
		GPIO_setOutputHighOnPin(GPIO_PORT_P5, GPIO_PIN3);
		GPIO_setOutputLowOnPin(GPIO_PORT_P5, GPIO_PIN5);
	}
	// Wait on sd card removal
	while (SD_AREG & SD_AFLAG_INSRT)
		;
	// wait on sd card insertion
	while ( ~ SD_AREG & SD_AFLAG_INSRT)
		;
	SD_MountFS();
	SD_OpentFile("AM.txt");
	SD_WriteToFile(
			"One night in Bangkok and the world's your oyster\rnot much between despair and ecstasy");
	SD_CloseFile();
	if (SD_EREG)
	{
		GPIO_setOutputHighOnPin(GPIO_PORT_P5, GPIO_PIN5);
		GPIO_setOutputLowOnPin(GPIO_PORT_P5, GPIO_PIN3);
		while (1)
			;
	}
	else
	{
		GPIO_setOutputHighOnPin(GPIO_PORT_P5, GPIO_PIN3);
		GPIO_setOutputLowOnPin(GPIO_PORT_P5, GPIO_PIN5);
	}
	// wait on sd card removal
	while (SD_AREG & SD_AFLAG_INSRT)
		;
	// wait on sd card insertion...
	while ( ~ SD_AREG & SD_AFLAG_INSRT)
		;
	SD_MountFS();
	SD_OpentFile("KG.txt");
	SD_WriteToFile("Get down on it!\rIf you really want it!");
	SD_CloseFile();
	if (SD_EREG)
	{
		GPIO_setOutputHighOnPin(GPIO_PORT_P5, GPIO_PIN5);
		GPIO_setOutputLowOnPin(GPIO_PORT_P5, GPIO_PIN3);
		while (1)
			;
	}
	else
	{
		GPIO_setOutputHighOnPin(GPIO_PORT_P5, GPIO_PIN3);
		GPIO_setOutputLowOnPin(GPIO_PORT_P5, GPIO_PIN5);
	}
	LPM0;
}

